import { __assign, __decorate } from 'tslib';
import { ElementRef, Renderer2, Input, Directive, NgModule } from '@angular/core';

var Blink = /** @class */ (function () {
    function Blink() {
        this.keyframes = [
            { transform: 'scale(1)' },
            { transform: 'scale(0.93)' },
            { transform: 'scale(0.95)' },
            { transform: 'scale(0.91)' },
            { transform: 'scale(1)' }
        ];
    }
    Blink.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Blink;
}());

var Bounce = /** @class */ (function () {
    function Bounce() {
        this.keyframes = [
            { transform: 'translate(0, 0)' },
            { transform: 'translate(0, 3px)' },
            { transform: 'translate(0, -6px)' },
            { transform: 'translate(0, 3px)' },
            { transform: 'translate(0, 0)' },
        ];
    }
    Bounce.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Bounce;
}());

var defaultDuration = 2000;

var Fade = /** @class */ (function () {
    function Fade() {
        this.keyframes = [
            { opacity: '1' },
            { opacity: '0.6' },
            { opacity: '0.8' },
            { opacity: '1' },
        ];
    }
    Fade.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Fade;
}());

var Flicker = /** @class */ (function () {
    function Flicker() {
        this.keyframes = [
            { transform: 'skewX(0deg)' },
            { transform: 'skewX(10deg)' },
            { transform: 'skewX(-10deg)' },
            { transform: 'skewX(5deg)' },
            { transform: 'skewX(-5deg)' },
            { transform: 'skewX(0deg)' },
        ];
    }
    Flicker.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Flicker;
}());

var Groove = /** @class */ (function () {
    function Groove() {
        this.keyframes = [
            { transform: 'skewY(0deg) rotate(0deg)' },
            { transform: 'skewY(-10deg) rotateZ(8deg)' },
            { transform: 'skewY(10deg) rotateZ(-8deg)' },
            { transform: 'skewY(6deg) rotateZ(4deg)' },
            { transform: 'skewY(0deg) rotate(0deg)' },
        ];
    }
    Groove.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Groove;
}());

var Jelly = /** @class */ (function () {
    function Jelly() {
        this.keyframes = [
            { transform: 'scaleX(1)' },
            { transform: 'scaleX(0.9)' },
            { transform: 'scaleX(1.25)' },
            { transform: 'scaleX(0.8)' },
            { transform: 'scaleX(1)' }
        ];
    }
    Jelly.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Jelly;
}());

var Jerk = /** @class */ (function () {
    function Jerk() {
        this.keyframes = [
            { transform: 'translateX(0px) rotateZ(0deg)' },
            { transform: 'translateX(-5px) rotateZ(-15deg)' },
            { transform: 'translateX(5px) rotateZ(15deg)' },
            { transform: 'translateX(-3px) rotateZ(5deg)' },
            { transform: 'translateX(3px) rotateZ(-5deg)' },
            { transform: 'translateX(0px) rotateZ(0deg)' },
        ];
    }
    Jerk.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Jerk;
}());

var Pop = /** @class */ (function () {
    function Pop() {
        this.keyframes = [
            { transform: 'scaleX(1) scaleY(1)' },
            { transform: 'scaleX(1.35) scaleY(0.1)' },
            { transform: 'scaleX(0.8) scaleY(1.7)' },
            { transform: 'scaleX(0.6) scaleY(0.85)' },
            { transform: 'scaleX(1) scaleY(1)' },
        ];
    }
    Pop.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Pop;
}());

var Shake = /** @class */ (function () {
    function Shake() {
        this.keyframes = [
            { transform: 'translateX(0px)' },
            { transform: 'translateX(-3px)' },
            { transform: 'translateX(3px)' },
            { transform: 'translateX(-2px)' },
            { transform: 'translateX(3px)' },
            { transform: 'translateX(-2px)' },
            { transform: 'translateX(0px)' },
        ];
    }
    Shake.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Shake;
}());

var Squeeze = /** @class */ (function () {
    function Squeeze() {
        this.keyframes = [
            { transform: 'scaleY(1)' },
            { transform: 'scaleY(0.95)' },
            { transform: 'scaleY(0.9)' },
            { transform: 'scaleY(0.75)' },
            { transform: 'scaleY(1.3)' },
            { transform: 'scaleY(0.95)' },
            { transform: 'scaleY(1)' },
        ];
    }
    Squeeze.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Squeeze;
}());

var Swing = /** @class */ (function () {
    function Swing() {
        this.keyframes = [
            { transform: 'rotateZ(0deg)' },
            { transform: 'rotateZ(15deg)' },
            { transform: 'rotateZ(-15deg)' },
            { transform: 'rotateZ(7deg)' },
            { transform: 'rotateZ(-7deg)' },
            { transform: 'rotateZ(0deg)' },
        ];
    }
    Swing.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Swing;
}());

var Tada = /** @class */ (function () {
    function Tada() {
        this.keyframes = [
            { transform: 'scale(1)' },
            { transform: 'scale(1.1) rotate(3deg)' },
            { transform: 'scale(0.97)' },
            { transform: 'scale(0.99) rotate(-3deg)' },
            { transform: 'scale(1.05)' },
            { transform: 'scale(1)' },
        ];
    }
    Tada.prototype.start = function (elementRef, _a) {
        var duration = _a.duration;
        elementRef.nativeElement.animate(this.keyframes, { duration: duration });
    };
    return Tada;
}());

var INTERACTION_TYPES = {
    blink: Blink,
    bounce: Bounce,
    fade: Fade,
    flicker: Flicker,
    groove: Groove,
    jelly: Jelly,
    jerk: Jerk,
    pop: Pop,
    shake: Shake,
    squeeze: Squeeze,
    swing: Swing,
    tada: Tada
};
var NgMicroInteractFactory = /** @class */ (function () {
    function NgMicroInteractFactory() {
    }
    NgMicroInteractFactory.setInteraction = function (type, element, options) {
        return new INTERACTION_TYPES[type]()
            .start(element, __assign({ duration: defaultDuration, easing: 'cubic-bezier(0.25, 0.1, 0.25, 1.0)' }, options));
    };
    return NgMicroInteractFactory;
}());

var NgMicroInteractDirective = /** @class */ (function () {
    function NgMicroInteractDirective(el, renderer) {
        this.el = el;
        this.renderer = renderer;
        this.type = 'fade';
        this.trigger = 'mouseover';
    }
    NgMicroInteractDirective.prototype.ngAfterViewInit = function () {
        this.registerEventListeners();
    };
    NgMicroInteractDirective.prototype.registerEventListeners = function () {
        var _this = this;
        this.renderer.listen(this.el.nativeElement, this.trigger, function () {
            NgMicroInteractFactory.setInteraction(_this.type, _this.el, _this.options);
        });
    };
    NgMicroInteractDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 }
    ]; };
    __decorate([
        Input()
    ], NgMicroInteractDirective.prototype, "type", void 0);
    __decorate([
        Input()
    ], NgMicroInteractDirective.prototype, "trigger", void 0);
    __decorate([
        Input()
    ], NgMicroInteractDirective.prototype, "options", void 0);
    NgMicroInteractDirective = __decorate([
        Directive({
            selector: '[ngMicroInteract]'
        })
    ], NgMicroInteractDirective);
    return NgMicroInteractDirective;
}());

var NgMicroInteractModule = /** @class */ (function () {
    function NgMicroInteractModule() {
    }
    NgMicroInteractModule = __decorate([
        NgModule({
            declarations: [NgMicroInteractDirective],
            imports: [],
            exports: [NgMicroInteractDirective]
        })
    ], NgMicroInteractModule);
    return NgMicroInteractModule;
}());

/*
 * Public API Surface of ng-micro-interact
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgMicroInteractDirective, NgMicroInteractModule };
//# sourceMappingURL=ng-micro-interact.js.map
